DEFINT A-Z
'$INCLUDE: 'Define.bi'

FUNCTION FileOpen$ (TitleS$, DefPath$, DefFile$, DefExt$)
DIM FOForm AS form
DIM FODrive AS ComboBox
DIM FODir AS ListBox
DIM FOFile AS ListBox
DIM FOName AS TextBox
DIM FOType AS ComboBox
DIM FOFrame1 AS Frame
DIM FOFrame2 AS Frame
DIM FOOK AS Button
DIM FOCancel AS Button
REDIM extarr(50) AS STRING

DP$ = DefPath$
DF$ = DefFile$
DE$ = DefExt$


IF DP$ = "" THEN DP$ = GetCurDir
IF DE$ <> "" THEN
IF RIGHT$(DE$, 1) <> "&" THEN DE$ = DE$ + "&"
CALL UnPackString(DE$, extarr(), Rows, Cols)
Array = newArray(Rows, Cols + 1)
FOR I = 1 TO Rows
putarrs Array, I, extarr(I)
NEXT
ELSE
extarr(1) = "*.*"
END IF

splitPath DP$, Drive$, Dire$, file$, ext$

IF Sys.MaxY = 200 THEN SH = -50
IF Sys.MaxY > 600 THEN SH = 150

CreateForm FOForm.ID, 1, Sys.MaxX / 2 - 165, Sys.MaxY / 2 - 100, 330, 200 + SH, TitleS$
FOForm.Style = CNoMin OR CNoMax OR CNoResize OR CModal

CreateControl FODrive.ID, FOForm.ID, OComboBox, 1, 0, 0, 100, 16, Drive$
FODrive.Font = 2
FODrive.Array = newArray(25, 6)
GetDrives FODrive.Array

CreateControl FODir.ID, FOForm.ID, OListBox, 1, 0, 22, 100, 140 + SH, ""
FODir.Style = CDinamicRows OR CNoSelect
FODir.ScrollBar = 1

FODir.Array = newArray(1000, 13)
GetDirs DP$, FODir.Array

CreateControl FOFile.ID, FOForm.ID, OListBox, 1, 105, 0, 220, 131 + SH, ""
FOFile.Style = CDinamicRows OR CNoSelect
FOFile.ScrollBar = 1
FOFile.Cols = 2
FOFile.Array = newArray(1000, 13)
GetFiles DP$, FOFile.Array, extarr(1)

CreateControl FOFrame1.ID, FOForm.ID, OFrame, 1, 105, 135 + SH, 48, 18, "File"
FOFrame1.Style = CNoBorder
CreateControl FOFrame2.ID, FOForm.ID, OFrame, 1, 105, 155 + SH, 48, 18, "Type"
FOFrame2.Style = CNoBorder

CreateControl FOName.ID, FOForm.ID, OTextBox, 1, 155, 135 + SH, 100, 18, DF$
FOName.Style = CNoSelect

CreateControl FOType.ID, FOForm.ID, OComboBox, 1, 155, 155 + SH, 100, 18, extarr(1)
FOType.Array = Array
CreateControl FOOK.ID, FOForm.ID, OButton, 1, 260, 135 + SH, 60, 18, "OK"
FOOK.Style = CCenter
FOOK.Font = 2
CreateControl FOCancel.ID, FOForm.ID, OButton, 1, 260, 155 + SH, 60, 18, "Cancel"
FOCancel.Font = 2
FOCancel.Style = CCenter
Refreshed = 1
DO
CALL ClearEvents
CALL GetEvent(XMouse, XMouse1, Ymouse, YMouse1, BMouse, BMouse1, ScanCode, ScanCode1)
ID = GetControl(XMouse, Ymouse)
CALL PostEvent(ID, XMouse, XMouse1, Ymouse, YMouse1, BMouse, BMouse1, ScanCode, ScanCode1, KeyCode$)
CALL ProgEvent(ID, XMouse, XMouse1, Ymouse, YMouse1, BMouse, BMouse1, ScanCode, KeyCode$)
'----------------------------------
IF FOForm.FEvent.FClose OR FOCancel.SEvent.LMClick OR KeyCode$ = CHR$(27) THEN
D$ = ""
EXIT DO
END IF
IF FODrive.SEvent.Change THEN
IF isdiskready(title(FODrive.ID)) THEN
DP$ = title(FODrive.ID)
Drive$ = DP$
GetDirs DP$, FODir.Array
GetFiles DP$, FOFile.Array, title(FOType.ID)
refresh FOForm.ID
ELSE
title(FODrive.ID) = Drive$
END IF
END IF
IF FODir.SEvent.LMDblClick THEN
P$ = getarrs(FODir.Array, FODir.Index)
IF P$ = ".." THEN
FOR I = LEN(DP$) - 1 TO 1 STEP -1
s$ = MID$(DP$, I, 1)
IF s$ = "\" THEN
DP$ = MID$(DP$, 1, I)

GetDirs DP$, FODir.Array
GetFiles DP$, FOFile.Array, title(FOType.ID)
title(FOName.ID) = ""
refresh FOFile.ID
refresh FODir.ID
refresh FOName.ID

EXIT FOR
END IF
NEXT
ELSEIF P$ <> ".." AND P$ <> "" THEN
DP$ = DP$ + P$ + "\"
GetDirs DP$, FODir.Array
GetFiles DP$, FOFile.Array, title(FOType.ID)
title(FOName.ID) = ""
refresh FOFile.ID
refresh FODir.ID
refresh FOName.ID
END IF
END IF
IF FOType.SEvent.Change THEN
GetFiles DP$, FOFile.Array, title(FOType.ID)
title(FOName.ID) = ""
refresh FOFile.ID
END IF
IF FOFile.SEvent.LMDblClick OR FOOK.SEvent.LMClick OR (FOFile.SEvent.KeyDown AND KeyCode$ = CHR$(13)) THEN
D$ = DP$ + title(FOName.ID)
EXIT DO
END IF


IF FOFile.SEvent.Change THEN
title(FOName.ID) = getarrs(FOFile.Array, FOFile.Index)
refresh FOName.ID
END IF







'----------------------------------
IF Refreshed THEN Future.MouseOff
loadforms
IF Refreshed THEN Future.MouseOn
Refreshed = 0
LOOP
FileOpen$ = D$
deleteControl FOForm.ID
refresh 1

END FUNCTION

FUNCTION InputBox$ (TitleS$, Text$, Default$)
DIM inputBoxForm AS form
                                      
DIM inputBox1Button AS Button            '  1 OK
DIM inputBox2Button AS Button            '  2 Cancell
DIM inputBoxFrame AS Frame
DIM inputBoxText AS TextBox

CreateForm inputBoxForm.ID, 1, Sys.MaxX / 2 - 150, Sys.MaxY / 2 - 75, 300, 150, TitleS$
inputBoxForm.Style = CNoMin OR CNoMax OR CNoResize OR CModal

CreateControl inputBoxFrame.ID, inputBoxForm.ID, OFrame, 1, 1, 1, inputBoxForm.XLen - 10, inputBoxForm.yLen - 75, Text$
inputBoxFrame.Style = CNoBorder OR CCenter

CreateControl inputBoxText.ID, inputBoxForm.ID, OTextBox, 1, 5, inputBoxForm.yLen - 70, inputBoxForm.XLen - 15, 20, Default$
focus.ID = inputBoxText.ID

CreateControl inputBox1Button.ID, inputBoxForm.ID, OButton, 1, inputBoxForm.XLen - 200, inputBoxForm.yLen - 45, 95, 20, "Ok"
CreateControl inputBox2Button.ID, inputBoxForm.ID, OButton, 1, inputBoxForm.XLen - 100, inputBoxForm.yLen - 45, 95, 20, "Cancel"
inputBox1Button.Style = CCenter
inputBox2Button.Style = CCenter
Refreshed = 1

DO
CALL ClearEvents
CALL GetEvent(XMouse, XMouse1, Ymouse, YMouse1, BMouse, BMouse1, ScanCode, ScanCode1)
ID = GetControl(XMouse, Ymouse)
CALL PostEvent(ID, XMouse, XMouse1, Ymouse, YMouse1, BMouse, BMouse1, ScanCode, ScanCode1, KeyCode$)
CALL ProgEvent(ID, XMouse, XMouse1, Ymouse, YMouse1, BMouse, BMouse1, ScanCode, KeyCode$)
'----------------------------------
IF inputBoxForm.FEvent.FClose OR inputBox2Button.SEvent.LMClick OR KeyCode$ = CHR$(27) THEN
InputBox = ""
EXIT DO
END IF
IF inputBox1Button.SEvent.LMClick OR KeyCode$ = CHR$(13) THEN
InputBox = title(inputBoxText.ID)
EXIT DO
END IF


'----------------------------------
IF Refreshed THEN Future.MouseOff
loadforms
IF Refreshed THEN Future.MouseOn
Refreshed = 0
LOOP

deleteControl inputBoxForm.ID
refresh 1


END FUNCTION

FUNCTION MsgBox (TitleS$, Text$, picture$, CMsgButtons)
DIM MsgBoxForm AS form
                                       
DIM MsgBox1Button AS Button            '  1 Ok or Yes
DIM MsgBox2Button AS Button            '  2 No
DIM MsgBox3Button AS Button            '  3 Cancel
DIM MsgBoxPicture AS PictureBOX
DIM MsgBoxFrame AS Frame

CreateForm MsgBoxForm.ID, 1, Sys.MaxX / 2 - 150, Sys.MaxY / 2 - 75, 300, 150, TitleS$
MsgBoxForm.Style = CNoMin OR CNoMax OR CNoResize OR CModal

IF picture$ = "" THEN
CreateControl MsgBoxFrame.ID, MsgBoxForm.ID, OFrame, 1, 1, 1, MsgBoxForm.XLen - 15, MsgBoxForm.yLen - 50, Text$
MsgBoxFrame.Style = CNoBorder OR CCenter
ELSE

CreateControl MsgBoxPicture.ID, MsgBoxForm.ID, OPictureBox, 1, 10, 10, 50, 50, picture$
MsgBoxPicture.Style = CNoBorder
CreateControl MsgBoxFrame.ID, MsgBoxForm.ID, OFrame, 1, 60, 1, MsgBoxForm.XLen - 15 - 60, MsgBoxForm.yLen - 50, Text$
MsgBoxFrame.Style = CNoBorder OR CCenter

END IF


IF CMsgButtons = 1 OR CMsgButtons = 0 THEN
CreateControl MsgBox1Button.ID, MsgBoxForm.ID, OButton, 1, MsgBoxForm.XLen - 100, MsgBoxForm.yLen - 45, 95, 20, "OK"
ELSEIF CMsgButtons = 2 THEN
CreateControl MsgBox1Button.ID, MsgBoxForm.ID, OButton, 1, MsgBoxForm.XLen - 200, MsgBoxForm.yLen - 45, 95, 20, "Yes"
CreateControl MsgBox2Button.ID, MsgBoxForm.ID, OButton, 1, MsgBoxForm.XLen - 100, MsgBoxForm.yLen - 45, 95, 20, "No"
ELSEIF CMsgButtons = 3 THEN
CreateControl MsgBox1Button.ID, MsgBoxForm.ID, OButton, 1, MsgBoxForm.XLen - 300, MsgBoxForm.yLen - 45, 95, 20, "Yes"
CreateControl MsgBox2Button.ID, MsgBoxForm.ID, OButton, 1, MsgBoxForm.XLen - 200, MsgBoxForm.yLen - 45, 95, 20, "No"
CreateControl MsgBox3Button.ID, MsgBoxForm.ID, OButton, 1, MsgBoxForm.XLen - 100, MsgBoxForm.yLen - 45, 95, 20, "Cancel"
END IF
MsgBox1Button.Style = CCenter
MsgBox2Button.Style = CCenter
MsgBox3Button.Style = CCenter
Refreshed = 1

DO
CALL ClearEvents
CALL GetEvent(XMouse, XMouse1, Ymouse, YMouse1, BMouse, BMouse1, ScanCode, ScanCode1)
ID = GetControl(XMouse, Ymouse)
CALL PostEvent(ID, XMouse, XMouse1, Ymouse, YMouse1, BMouse, BMouse1, ScanCode, ScanCode1, KeyCode$)
CALL ProgEvent(ID, XMouse, XMouse1, Ymouse, YMouse1, BMouse, BMouse1, ScanCode, KeyCode$)
'----------------------------------
IF MsgBoxForm.FEvent.FClose OR MsgBox3Button.SEvent.LMClick OR KeyCode$ = CHR$(27) THEN
MsgBox = 3
EXIT DO
END IF
IF MsgBox1Button.SEvent.LMClick OR KeyCode$ = CHR$(13) THEN
MsgBox = 1
EXIT DO
END IF
IF MsgBox2Button.SEvent.LMClick THEN
MsgBox = 2
EXIT DO
END IF


'----------------------------------
IF Refreshed THEN Future.MouseOff
loadforms
IF Refreshed THEN Future.MouseOn
Refreshed = 0
LOOP

deleteControl MsgBoxForm.ID
refresh 1


END FUNCTION

FUNCTION PathOpen$ (TitleS$, DefPath$)
DIM POForm AS form
DIM PODrive AS ComboBox
DIM PODir AS ListBox
DIM POFR1 AS Frame

DIM POOK AS Button
DIM POCancel AS Button

DP$ = DefPath$

IF DP$ = "" THEN DP$ = GetCurDir

splitPath DP$, Drive$, Dire$, file$, ext$


CreateForm POForm.ID, 1, Sys.MaxX / 2 - 165, Sys.MaxY / 2 - 100, 225, 200, TitleS$
POForm.Style = CNoMin OR CNoMax OR CNoResize OR CModal

CreateControl PODrive.ID, POForm.ID, OComboBox, 1, 0, 2, 100, 16, Drive$
PODrive.Font = 2
PODrive.Array = newArray(25, 6)
GetDrives PODrive.Array

CreateControl POFR1.ID, POForm.ID, OFrame, 1, 105, 2, 110, 16, ""
POFR1.Font = 2
CreateControl PODir.ID, POForm.ID, OListBox, 1, 0, 22, 220, 128, DP$
PODir.Style = CDinamicRows OR CNoSelect
PODir.ScrollBar = 1
PODir.Cols = 2

PODir.Array = newArray(2000, 13)

GetDirs DP$, PODir.Array

CreateControl POOK.ID, POForm.ID, OButton, 1, 150, 155, 60, 18, "OK"
POOK.Style = CCenter
POOK.Font = 2
CreateControl POCancel.ID, POForm.ID, OButton, 1, 65, 155, 60, 18, "Cancel"
POCancel.Font = 2
POCancel.Style = CCenter
Refreshed = 1
DO
CALL ClearEvents
CALL GetEvent(XMouse, XMouse1, Ymouse, YMouse1, BMouse, BMouse1, ScanCode, ScanCode1)
ID = GetControl(XMouse, Ymouse)
CALL PostEvent(ID, XMouse, XMouse1, Ymouse, YMouse1, BMouse, BMouse1, ScanCode, ScanCode1, KeyCode$)
CALL ProgEvent(ID, XMouse, XMouse1, Ymouse, YMouse1, BMouse, BMouse1, ScanCode, KeyCode$)
'----------------------------------
IF POForm.FEvent.FClose OR POCancel.SEvent.LMClick OR KeyCode$ = CHR$(27) THEN
D$ = ""
EXIT DO
END IF
IF PODrive.SEvent.Change THEN
IF isdiskready(title(PODrive.ID)) THEN
DP$ = title(PODrive.ID)
Drive$ = DP$
GetDirs DP$, PODir.Array
refresh POForm.ID
ELSE
title(PODrive.ID) = Drive$
END IF
END IF
IF PODir.SEvent.LMDblClick THEN
P$ = getarrs(PODir.Array, PODir.Index)
IF P$ = ".." THEN
        FOR I = LEN(DP$) - 1 TO 1 STEP -1
                s$ = MID$(DP$, I, 1)
                IF s$ = "\" THEN
                        DP$ = MID$(DP$, 1, I)
                        GetDirs DP$, PODir.Array
                        title(PODir.ID) = DP$
                        refresh PODir.ID
                        EXIT FOR
                END IF
        NEXT
ELSEIF P$ <> ".." AND P$ <> "" THEN
        DP$ = DP$ + P$ + "\"
        GetDirs DP$, PODir.Array
        title(PODir.ID) = DP$
        refresh PODir.ID
END IF

END IF
IF PODir.SEvent.Change THEN
title(POFR1.ID) = getarrs(PODir.Array, PODir.Index)
refresh POFR1.ID
END IF

IF POOK.SEvent.LMClick THEN

D$ = getarrs(PODir.Array, PODir.Index)
IF D$ <> ".." AND D$ <> "" THEN D$ = title(PODir.ID) + D$ + "\" ELSE D$ = title(PODir.ID)
EXIT DO
END IF

'----------------------------------
IF Refreshed THEN Future.MouseOff
loadforms
IF Refreshed THEN Future.MouseOn
Refreshed = 0
LOOP
PathOpen$ = D$
deleteControl POForm.ID
refresh 1






END FUNCTION

FUNCTION PopUpList (XPos, YPos, XLen, yLen, Style, Array)
DIM PopUpForm AS form
DIM PopUpListBox AS ListBox

Maxlen = GetArrCols(Array)
max = GetFArrRows(Array)

'---------------------------------
ft = Sys.Font
IF ft = 0 THEN fts = 8
IF ft = 1 THEN fts = 16
IF ft = 2 THEN fts = 14

IF yLen = 0 THEN MaxY = max * fts + 4 ELSE MaxY = yLen
IF XLen = 0 THEN MaxX = Maxlen * 8 + 4 ELSE MaxX = XLen
IF Style = 2 AND XLen = 0 THEN MaxX = MaxX + 10
IF MaxY > 200 AND yLen = 0 THEN MaxY = 200
IF MaxY > max * fts + 4 THEN MaxY = max * fts + 4
X = XPos
Y = YPos
IF X + MaxX > Sys.MaxX THEN X = Sys.MaxX - MaxX
IF Y + MaxY > Sys.MaxY THEN Y = Sys.MaxY - MaxY
IF X < 0 THEN X = 0
IF Y < 0 THEN Y = 0

CreateForm PopUpForm.ID, 1, X, Y, MaxX, MaxY, ""
CreateControl PopUpListBox.ID, PopUpForm.ID, OListBox, 1, -2, -Sys.HeadSize, MaxX, MaxY, ""
focus.ID = PopUpListBox.ID
PopUpListBox.Style = CNoSelect OR CDinamicRows

IF Style = 0 THEN
PopUpListBox.UpColor = Sys.UpColor
PopUpListBox.DownColor = Sys.DownColor
PopUpListBox.BColor = Sys.BColor
PopUpListBox.TColor = Sys.TColor
ELSEIF Style = 2 THEN
PopUpListBox.ScrollBar = CVertical
END IF

PopUpListBox.Array = Array
Refreshed = 1
DO
CALL ClearEvents
CALL GetEvent(XMouse, XMouse1, Ymouse, YMouse1, BMouse, BMouse1, ScanCode, ScanCode1)
ID = GetControl(XMouse, Ymouse)
CALL PostEvent(ID, XMouse, XMouse1, Ymouse, YMouse1, BMouse, BMouse1, ScanCode, ScanCode1, KeyCode$)
CALL ProgEvent(ID, XMouse, XMouse1, Ymouse, YMouse1, BMouse, BMouse1, ScanCode, KeyCode$)
'----------------------------------
IF KeyCode$ = CHR$(27) THEN
PopUpList = 0
EXIT DO
END IF
IF KeyCode$ = CHR$(13) THEN
PopUpList = PopUpListBox.Index
EXIT DO
END IF

IF BMouse <> 0 AND (PopUpForm.XPos > XMouse OR PopUpForm.XPos + PopUpForm.XLen < XMouse OR PopUpForm.YPos > Ymouse OR PopUpForm.YPos + PopUpForm.yLen < Ymouse) THEN
PopUpList = 0
EXIT DO
END IF
IF PopUpListBox.SEvent.LMClick THEN
PopUpList = PopUpListBox.Index
EXIT DO


END IF

'----------------------------------
IF Refreshed THEN Future.MouseOff
loadforms
IF Refreshed THEN Future.MouseOn
Refreshed = 0
LOOP

PopUpListBox.Array = 0         'make sure array won't be deleted
deleteControl PopUpForm.ID
refresh 1


END FUNCTION

FUNCTION PopUpMenu (XPos, YPos, MenuString$)

REDIM MNU(50) AS STRING
'---------------------------------
CALL UnPackString(MenuString$, MNU(), Rows, Cols)
Array = newArray(Rows, Cols + 1)
FOR I = 1 TO Rows
putarrs Array, I, MNU(I)

NEXT

R = PopUpList(XPos, YPos, XLen, yLen, 0, Array)
DeallocateXMS Array
PopUpMenu = R
'---------------------------------

END FUNCTION

